INFO IN PROGRESS OF BEING MOVED TO NOTEBOOK


Things needed to build a development docker image based on WARA PS base LRS image.

Also instructions how to run different units from a docker. This will
replace the setup we have had with virtual machines that Combitech
have used.

Will be used for more things in the future.


### Create Executors for DJI
Add
```bash
exec_dji roslaunch lrs_launch exec_part.launch ns:=/dji0 vehicle:=dji
```

### Create Needed Operator

```bash
wdb roslaunch lrs_launch wdb.launch vehicle:=op ns:=/op0
```

```bash
tst roslaunch lrs_launch tst_part ns:=/op0
```

```bash
exec_op roslaunch lrs_launch exec_part.launch ns:=/op0 vehicle:=op
```




## Running Sub Systems from Docker

WORK IN PROGRESS!

### Define a location

```bash
roslaunch lrs_launch location_granso.launch ns:=/dji0
```

### Scripts to start docker containers (and pull)

- base_dji
- dji_system
- wdb 

### Dji Simulator with MPC Trajectory Controller

```bash
	docker run \
	  --network host \
	  --security-opt apparmor:unconfined \
	  --ulimit nofile=1024 \
	  -e ROS_HOSTNAME=localhost \
	  --rm -it gitlab.liu.se:5000/lrs/waraps_docker_images/base-dji-minimal:v01 \
          roslaunch lrs_dji_sim sim.launch dynamics:=true mpc:=true inair:=true ns:=/dji0 basic:=false
```

or

```bash
base_dji roslaunch lrs_dji_sim sim.launch dynamics:=true mpc:=true inair:=true ns:=/dji0 basic:=false gazebo:=true
```

### Create a LRS DJI 
Add
```bash
dji_system roslaunch lrs_launch lrsdji.launch publish_pose:=false ns:=/dji0
```

### Create a WDB LRS DJI 
Add
```bash
wdb roslaunch lrs_launch wdb.launch vehicle:=dji ns:=/dji0
```

### Create TST Factory for Execution Trees
Add
```
tst roslaunch lrs_launch tst_part.launch ns:=/dji0
```

### Create Executors for DJI
Add
```bash
exec_dji roslaunch lrs_launch exec_part.launch ns:=/dji0 vehicle:=dji
```

### Create Needed Operator

```bash
wdb roslaunch lrs_launch wdb.launch vehicle:=op ns:=/op0
```

```bash
tst roslaunch lrs_launch tst_part.launch ns:=/op0
```

```bash
exec_op roslaunch lrs_launch exec_part.launch ns:=/op0 vehicle:=op
```

### Putting it all together in two screens



## Running units from docker

Start docker with wrun or wgrun. Use wgrun ig you have NVIDIA graphics
working in dockers using the new method with the flag "--gpus".

### Running units on different computer

To start /op0, /djisim0, /djisim1, /pirayasim0 do:
```bash
wrun op 0
```

```bash
wrun djisim 0
```

```bash
wrun djisim 1
```
```bash
wrun pirayasim 0
```


### Running units on the same computer

here we just start one container and then used "docker exec" to get different shells.

Start the docker container:
```bash
wrun bash
```
Can be detached with C-p C-q.

To start /op0, /djisim0, /djisim1, /pirayasim0 do:
```bash
wexec
op 0
```

```bash
wexec
djisim 0
```

```bash
wexec
djisim 1
```
```bash
wexec
pirayasim 0
```


## User Specific Development Docker

THIS INFORMATION IS NOT YET COMPLETE! DO NOT USE!

### Build user specific development docker image

```bash
cd docker
./build
```

### Run the user specific developer image

```bash
cd docker
./run.sh ${HOME}/wara_docker_home
```

The run.sh script takes one argument and it is the directory that is mounted as home directory.

### Init files

You have to create your own init files.

To get access to the ROS-repos put:
```bash
source /opt/lrs_wara/wara_devel_ws/deve/setup.bash
```

in your .bashrc file.

