#!/bin/bash

# Basic script to just build the personal docker image without any bells and
# whistles

exec docker build \
     --no-cache \
     --file Dockerfile \
     --build-arg user="$USER" \
     --build-arg uid="$UID" \
     --build-arg home="$HOME" \
     --build-arg workspace="$HOME"/wara_ws \
     -t ros:waraps-"$USER" .
